"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Compare bodyguard keys of a user against an identifier/value pair to see if
 * 	they match
 * @param identifier Identifier field name
 * @param value Identifier field value
 * @param user User to check
 * @param userBodyguardKeys Array of user type bodyguard keys to check
 * @return Returns if the identifier is a valid bodyguard key and that
 * 	it also matches the user's key
 */
function compareIdToUser(identifier, value, user, userBodyguardKeys) {
    return userBodyguardKeys.includes(identifier) && value === user[identifier];
}
exports.compareIdToUser = compareIdToUser;
//# sourceMappingURL=compare-id-to-user.js.map