import { BaseModel, BaseUser } from '../models';
/**
 * Compare a nested User against a User for ownership
 * 	Example: Does obj->owner->id equal user->id?
 * @param obj Object to test
 * @param user User to test
 * @param objBodyguardKeys Key array from getBodyguardKeys(obj)
 * @param userBodyguardKeys Key array from getBodyguardKeys(user)
 * @return Returns if the user owns the given object
 */
export declare function compareNestedBodyguards(obj: BaseModel, user: BaseUser, objBodyguardKeys: string[], userBodyguardKeys: string[]): boolean;
