"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
/**
 * Compare a nested User against a User for ownership
 * 	Example: Does obj->owner->id equal user->id?
 * @param obj Object to test
 * @param user User to test
 * @param objBodyguardKeys Key array from getBodyguardKeys(obj)
 * @param userBodyguardKeys Key array from getBodyguardKeys(user)
 * @return Returns if the user owns the given object
 */
function compareNestedBodyguards(obj, user, objBodyguardKeys, userBodyguardKeys) {
    for (var _i = 0, objBodyguardKeys_1 = objBodyguardKeys; _i < objBodyguardKeys_1.length; _i++) {
        var objKey = objBodyguardKeys_1[_i];
        for (var _a = 0, userBodyguardKeys_1 = userBodyguardKeys; _a < userBodyguardKeys_1.length; _a++) {
            var userKey = userBodyguardKeys_1[_a];
            if (utils_1.isDefined(obj[objKey]) &&
                utils_1.isDefined(obj[objKey][userKey]) &&
                "" + obj[objKey][userKey] === "" + user[userKey]) {
                return true;
            }
        }
    }
    return false;
}
exports.compareNestedBodyguards = compareNestedBodyguards;
//# sourceMappingURL=compare-nested.js.map