"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var bodyguard_1 = require("../bodyguard");
/**
 * Get an array of searchable fields for the object
 * @param obj Object to receive keys for
 * @return Returns array of field names
 */
function getSearchableFields(obj) {
    var searchableFields = [];
    // Traverse members of object, and append CanSearch() keys
    // to searchableFields
    for (var member in obj) {
        if (bodyguard_1.getCanSearch(obj, member)) {
            searchableFields.push(member);
        }
    }
    // Return searchable fields
    return searchableFields;
}
exports.getSearchableFields = getSearchableFields;
//# sourceMappingURL=get-searchable-fields.js.map