"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var bodyguard_1 = require("../bodyguard");
/**
 * Get an array of searchable fields for the object
 * @param obj Object to receive keys for
 * @return Returns an array of field names
 */
function getSearchableRelations(obj) {
    var searchableFields = [];
    var _loop_1 = function (member) {
        var canSearchRelation = bodyguard_1.getCanSearchRelation(obj, member);
        if (canSearchRelation) {
            var fields = canSearchRelation.fields.map(function (field) {
                return member + "." + field;
            });
            searchableFields = searchableFields.concat(fields);
        }
    };
    for (var member in obj) {
        _loop_1(member);
    }
    return searchableFields;
}
exports.getSearchableRelations = getSearchableRelations;
//# sourceMappingURL=get-searchable-relations.js.map