"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var bcryptjs_1 = require("bcryptjs");
var jwt_bearer_1 = require("../jwt-bearer");
var run_hook_1 = require("../utils/run-hook");
var read_filter_1 = require("../bodyguard/read-filter");
/**
 * Login endpoint
 * @param request Request object to query by
 * @param response Response object to call responder with
 */
function loginEndpoint(request, response) {
    return __awaiter(this, void 0, void 0, function () {
        var fields, where, _i, fields_1, field, pair, foundUsers, match, expiration, token, refreshExpiration, refreshToken;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // Check input
                    if (!('__user' in request.body)) {
                        response.validationResponder('__user is required');
                        return [2 /*return*/];
                    }
                    if (!('password' in request.body)) {
                        response.validationResponder('password is required');
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, run_hook_1.runHook('login', request.body, request, response)];
                case 1:
                    // Run model hook
                    if (!(_a.sent())) {
                        return [2 /*return*/];
                    }
                    fields = ['username', 'email'];
                    if (request.userType && 'tempEmail' in new request.userType()) {
                        fields.push('tempEmail');
                    }
                    where = [];
                    for (_i = 0, fields_1 = fields; _i < fields_1.length; _i++) {
                        field = fields_1[_i];
                        pair = {};
                        pair[field] = request.body.__user;
                        where.push(pair);
                    }
                    return [4 /*yield*/, request.repository
                            .find({
                            where: where
                        })
                            .catch(function (error) { return response.error(error); })];
                case 2:
                    foundUsers = _a.sent();
                    // Check users
                    if (!foundUsers || !foundUsers.length) {
                        response.unauthorizedResponder('Could not authenticate user');
                        return [2 /*return*/];
                    }
                    if (foundUsers && foundUsers instanceof Array) {
                        foundUsers.forEach(function (foundUser) {
                            var isMatch = false;
                            if ('password' in request.body &&
                                request.body.password &&
                                'password' in foundUser &&
                                foundUser['password']) {
                                isMatch = bcryptjs_1.compareSync(request.body.password, foundUser['password']);
                            }
                            if (isMatch) {
                                match = foundUser;
                            }
                        });
                    }
                    if (!match) return [3 /*break*/, 6];
                    expiration = jwt_bearer_1.jwtBearer.getExpiration();
                    token = jwt_bearer_1.jwtBearer.sign(match);
                    refreshExpiration = jwt_bearer_1.jwtBearer.getExpiration(true);
                    refreshToken = jwt_bearer_1.jwtBearer.sign(match, true);
                    if (!(token && refreshToken)) return [3 /*break*/, 4];
                    // Set request user
                    request.user = match;
                    // Create response
                    match = read_filter_1.readFilter(match, request.user, request.payloadType, request.userType);
                    match['expiration'] = expiration;
                    match['token'] = token;
                    match['refreshExpiration'] = refreshExpiration;
                    match['refreshToken'] = refreshToken;
                    return [4 /*yield*/, run_hook_1.runHook('afterLogin', request.user, request, response)];
                case 3:
                    // Send response
                    if (!(_a.sent())) {
                        return [2 /*return*/];
                    }
                    response.json(match);
                    return [3 /*break*/, 5];
                case 4:
                    // Couldn't create token
                    response.error('Could not create create auth token');
                    _a.label = 5;
                case 5: return [3 /*break*/, 7];
                case 6:
                    // No match found
                    response.unauthorizedResponder('Could not authenticate user');
                    _a.label = 7;
                case 7: return [2 /*return*/];
            }
        });
    });
}
exports.loginEndpoint = loginEndpoint;
//# sourceMappingURL=login-endpoint.js.map