"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var jwt_bearer_1 = require("../jwt-bearer");
var run_hook_1 = require("../utils/run-hook");
var read_filter_1 = require("../bodyguard/read-filter");
var models_1 = require("../models");
/**
 * Refresh the user's token
 * @param request Request object to query by
 * @param response Response object to call responder with
 */
function refreshTokenEndpoint(request, response) {
    return __awaiter(this, void 0, void 0, function () {
        var token, match, expiration, token_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!('__refreshToken' in request.body)) return [3 /*break*/, 7];
                    token = jwt_bearer_1.jwtBearer.dryVerify(request.body.__refreshToken);
                    if (!(token && 'isRefresh' in token && token.isRefresh)) return [3 /*break*/, 5];
                    return [4 /*yield*/, request.repository
                            .findOne({ id: token.id })
                            .catch(function (error) { return response.error(error); })];
                case 1:
                    match = _a.sent();
                    if (!(match && match instanceof models_1.BaseUser)) return [3 /*break*/, 3];
                    expiration = jwt_bearer_1.jwtBearer.getExpiration();
                    token_1 = jwt_bearer_1.jwtBearer.sign(match);
                    // Set request user
                    request.user = match;
                    // Create response
                    match = read_filter_1.readFilter(match, request.user, request.payloadType, request.userType);
                    match['expiration'] = expiration;
                    match['token'] = token_1;
                    return [4 /*yield*/, run_hook_1.runHook('tokenRefresh', request.user, request, response)];
                case 2:
                    // Send response
                    if (!(_a.sent())) {
                        return [2 /*return*/];
                    }
                    response.json(match);
                    return [3 /*break*/, 4];
                case 3:
                    // No match found
                    response.unauthorizedResponder('Could not authenticate user');
                    _a.label = 4;
                case 4: return [3 /*break*/, 6];
                case 5:
                    // No match found
                    response.unauthorizedResponder('Could not authenticate user');
                    _a.label = 6;
                case 6: return [3 /*break*/, 8];
                case 7:
                    // Respond with 400
                    response.validationResponder('No refresh token sent');
                    _a.label = 8;
                case 8: return [2 /*return*/];
            }
        });
    });
}
exports.refreshTokenEndpoint = refreshTokenEndpoint;
//# sourceMappingURL=refresh-token-endpoint.js.map