"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var write_filter_1 = require("../bodyguard/write-filter");
/**
 * Post Filter: Filter a POST request payload, and respond with
 * 	403 Forbidden if the request contains any private fields
 * @param request Request object to query by
 * @param response Response object to call responder with
 * @param next Next function to call on success
 */
function postFilter(request, response, next) {
    // Posting new user is always self
    var isSelfResult;
    if (request.payloadType === request.userType) {
        isSelfResult = true;
    }
    // Filter request body
    var writeFilterResult = write_filter_1.writeFilter(request.body, request.user, request.payloadType, request.userType, isSelfResult);
    if (writeFilterResult === true) {
        // Post body is okay, proceed
        next();
    }
    else {
        // Cannot write member, respond with 403 Forbidden
        response.forbiddenResponder('Cannot write member ' + writeFilterResult);
    }
}
exports.postFilter = postFilter;
//# sourceMappingURL=post-filter.js.map