"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var base_user_1 = require("../models/base-user");
/**
 * Only User Guard: Return 401 Unauthorized if the user
 * 	is not logged in
 * @param request Request object to query by
 * @param response Response object to call responder with
 * @param next Next function to call on success
 */
function onlyUser(request, response, next) {
    if (request.user instanceof base_user_1.BaseUser) {
        // User is logged in
        next();
    }
    else {
        // User is not logged in, respond with 401 Unauthorized
        response.unauthorizedResponder('not user');
    }
}
exports.onlyUser = onlyUser;
//# sourceMappingURL=only-user.js.map