"use strict";
/**
 * # HttpClientResponse
 *
 * HttpClient requests return an object:
 *
 * - statusCode - The response status code
 * - response - The entire response object
 * - body - The JSON.parsed response body
 */
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
/**
 * HTTP Mock Client Response
 */
var HttpClientResponse = /** @class */ (function () {
    /**
     * Create a mock http response
     * @param response Response response object
     * @param body Response body
     */
    function HttpClientResponse(response, body) {
        this.statusCode = response ? response.statusCode : undefined;
        this.response = response;
        this.body = utils_1.isJson(body) ? JSON.parse(body) : body;
    }
    return HttpClientResponse;
}());
exports.HttpClientResponse = HttpClientResponse;
//# sourceMappingURL=http-client-response.js.map