import { BaseModel, BaseUserInterface, BaseModelInterface } from './models';
import { ErrorHandlerFunction, LogHandlerFunction, ResponderFunction } from './method-interface';
import { Repository } from 'typeorm';
declare global {
    namespace Express {
        interface Request {
            identifier?: string;
            user?: any;
            userType?: BaseUserInterface;
            payload?: BaseModel | BaseModel[];
            payloadType?: BaseModelInterface;
            repository?: Repository<BaseModel>;
            joinMembers?: string[];
        }
        interface Response {
            error: ErrorHandlerFunction;
            log: LogHandlerFunction;
            conflictResponder: ResponderFunction;
            forbiddenResponder: ResponderFunction;
            goneResponder: ResponderFunction;
            unauthorizedResponder: ResponderFunction;
            validationResponder: ResponderFunction;
            deleteResponder: ResponderFunction;
            getResponder: ResponderFunction;
            postResponder: ResponderFunction;
            patchResponder: ResponderFunction;
        }
    }
}
export { pointy, PointyApi } from './pointy-core';
export { JwtBearer, jwtBearer } from './jwt-bearer';
export { setModel } from './set-model';
