"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var get_identifier_value_1 = require("../utils/get-identifier-value");
/**
 * Load resource represented by the URL ID
 * Example:
 * 	/users/12 -> Load #12
 * @param request Express request
 * @param response Express response
 * @param next Next function to call on success
 * @return Returns a Promise of boolean
 */
function loadEntity(request, response, next) {
    return __awaiter(this, void 0, void 0, function () {
        var value, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!request.identifier) return [3 /*break*/, 4];
                    value = get_identifier_value_1.getIdentifierValue(request);
                    if (!value) return [3 /*break*/, 2];
                    return [4 /*yield*/, request.repository
                            .findOne(value)
                            .catch(function () { return response.error("Could not load entity"); })];
                case 1:
                    result = _a.sent();
                    if (result && result instanceof request.payloadType) {
                        request.payload = result;
                        if (next) {
                            next();
                            return [2 /*return*/, true];
                        }
                        else {
                            return [2 /*return*/, true];
                        }
                    }
                    else {
                        response.goneResponder("Could not load entity");
                        return [2 /*return*/, false];
                    }
                    return [3 /*break*/, 3];
                case 2:
                    response.validationResponder('Invalid request parameters');
                    _a.label = 3;
                case 3: return [3 /*break*/, 5];
                case 4:
                    response.error('Could not load entity on a route without a parameter');
                    return [2 /*return*/, false];
                case 5: return [2 /*return*/];
            }
        });
    });
}
exports.loadEntity = loadEntity;
//# sourceMappingURL=load-entity.js.map