"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var typeorm_1 = require("typeorm");
// Validation
var class_validator_1 = require("class-validator");
// Bodyguards
var bodyguard_1 = require("../bodyguard");
// Models
var base_user_1 = require("./base-user");
var enums_1 = require("../enums");
/**
 * Base User
 */
var ExampleUser = /** @class */ (function (_super) {
    __extends(ExampleUser, _super);
    function ExampleUser() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        // ID
        _this.id = undefined;
        // Time created
        _this.timeCreated = undefined;
        // Time last updated
        _this.timeUpdated = undefined;
        // Username
        _this.username = undefined;
        // First name
        _this.fname = undefined;
        // Last name
        _this.lname = undefined;
        // Email
        _this.email = undefined;
        // Password
        _this.password = undefined;
        // ExampleUser Role
        _this.role = undefined;
        // ExampleUser Status
        _this.status = undefined;
        // Biography
        _this.biography = undefined;
        // Geographical Location
        _this.location = undefined;
        // Thumbnail image
        _this.thumbnail = undefined;
        return _this;
    }
    __decorate([
        typeorm_1.PrimaryGeneratedColumn(),
        class_validator_1.IsInt(),
        class_validator_1.IsOptional(),
        bodyguard_1.BodyguardKey(),
        bodyguard_1.AnyoneCanRead(),
        __metadata("design:type", Number)
    ], ExampleUser.prototype, "id", void 0);
    __decorate([
        typeorm_1.Column({ type: 'timestamp', default: new Date() }),
        class_validator_1.IsDate(),
        class_validator_1.IsOptional(),
        bodyguard_1.AnyoneCanRead(),
        __metadata("design:type", Date)
    ], ExampleUser.prototype, "timeCreated", void 0);
    __decorate([
        typeorm_1.Column({ type: 'timestamp', default: new Date() }),
        class_validator_1.IsDate(),
        class_validator_1.IsOptional(),
        bodyguard_1.AnyoneCanRead(),
        __metadata("design:type", Date)
    ], ExampleUser.prototype, "timeUpdated", void 0);
    __decorate([
        typeorm_1.Column({ unique: true }),
        class_validator_1.Length(4, 16),
        class_validator_1.IsAlphanumeric(),
        bodyguard_1.AnyoneCanRead(),
        bodyguard_1.OnlySelfCanWrite(),
        bodyguard_1.CanSearch(),
        __metadata("design:type", String)
    ], ExampleUser.prototype, "username", void 0);
    __decorate([
        typeorm_1.Column({ nullable: true }),
        bodyguard_1.AnyoneCanRead(),
        bodyguard_1.OnlySelfCanWrite(),
        bodyguard_1.CanSearch(),
        __metadata("design:type", String)
    ], ExampleUser.prototype, "fname", void 0);
    __decorate([
        typeorm_1.Column({ nullable: true }),
        bodyguard_1.AnyoneCanRead(),
        bodyguard_1.OnlySelfCanWrite(),
        bodyguard_1.CanSearch(),
        __metadata("design:type", String)
    ], ExampleUser.prototype, "lname", void 0);
    __decorate([
        typeorm_1.Column({ nullable: true, unique: true }),
        class_validator_1.IsEmail(),
        class_validator_1.IsOptional(),
        bodyguard_1.OnlySelfCanRead(),
        bodyguard_1.OnlySelfCanWrite(),
        bodyguard_1.CanSearch(),
        __metadata("design:type", String)
    ], ExampleUser.prototype, "email", void 0);
    __decorate([
        typeorm_1.Column({ nullable: true }),
        bodyguard_1.OnlySelfCanWrite(),
        __metadata("design:type", String)
    ], ExampleUser.prototype, "password", void 0);
    __decorate([
        typeorm_1.Column({ default: enums_1.UserRole.Basic }),
        bodyguard_1.AnyoneCanRead(),
        bodyguard_1.OnlyAdminCanWrite(),
        __metadata("design:type", String)
    ], ExampleUser.prototype, "role", void 0);
    __decorate([
        typeorm_1.Column({ default: enums_1.UserStatus.Pending }),
        bodyguard_1.AnyoneCanRead(),
        bodyguard_1.OnlyAdminCanWrite(),
        __metadata("design:type", String)
    ], ExampleUser.prototype, "status", void 0);
    __decorate([
        typeorm_1.Column({ type: 'text', nullable: true }),
        bodyguard_1.AnyoneCanRead(),
        bodyguard_1.OnlySelfCanWrite(),
        __metadata("design:type", String)
    ], ExampleUser.prototype, "biography", void 0);
    __decorate([
        typeorm_1.Column({ nullable: true }),
        bodyguard_1.AnyoneCanRead(),
        bodyguard_1.OnlySelfCanWrite(),
        __metadata("design:type", String)
    ], ExampleUser.prototype, "location", void 0);
    __decorate([
        typeorm_1.Column({ nullable: true }),
        bodyguard_1.AnyoneCanRead(),
        bodyguard_1.OnlySelfCanWrite(),
        __metadata("design:type", String)
    ], ExampleUser.prototype, "thumbnail", void 0);
    ExampleUser = __decorate([
        typeorm_1.Entity('User')
    ], ExampleUser);
    return ExampleUser;
}(base_user_1.BaseUser));
exports.ExampleUser = ExampleUser;
//# sourceMappingURL=example-user.js.map