import { Application } from 'express';
import { BaseDb } from './database';
import { HttpClient } from './http/http-client';
import { ResponderFunction, ErrorHandlerFunction, LogHandlerFunction } from './method-interface';
import { BaseUserInterface } from './models';
/**
 * PointyAPI App Instance
 */
export declare class PointyApi {
    app: Application;
    listen: Function;
    db: BaseDb;
    http: HttpClient;
    userType: BaseUserInterface;
    testmode: boolean;
    log: LogHandlerFunction;
    error: ErrorHandlerFunction;
    conflictResponder: ResponderFunction;
    forbiddenResponder: ResponderFunction;
    goneResponder: ResponderFunction;
    unauthorizedResponder: ResponderFunction;
    validationResponder: ResponderFunction;
    deleteResponder: ResponderFunction;
    getResponder: ResponderFunction;
    postResponder: ResponderFunction;
    patchResponder: ResponderFunction;
    before: Function;
    ready: Function;
    constructor();
    readycheck(): boolean;
    start(): Promise<void>;
}
export declare const pointy: PointyApi;
