"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var bodyguard_1 = require("../bodyguard");
var utils_1 = require("../utils");
/**
 * Get the objects represented by the request query
 * @param request Request to query by
 * @param response Response object to respond with
 * @return Returns a Promise of an array or single object
 */
function getQuery(request, response) {
    return __awaiter(this, void 0, void 0, function () {
        var shouldCount, readableFields, selectKeys, _i, _a, key, groupByKeys_2, orderByKeys, orderByOrders, key, _b, queryString, queryParams, bodyguardKeys, selection, _c, _d, table, query, _e, groupByKeys_1, key, i, key, prestring_1;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    if (!('query' in request && 'id' in request.query && request.query.id)) return [3 /*break*/, 1];
                    // Read one
                    return [2 /*return*/, request.repository.findOne(request.query.id)];
                case 1:
                    if (!('query' in request && Object.keys(request.query).length)) return [3 /*break*/, 7];
                    shouldCount = 'count' in request.query && request.query.count;
                    readableFields = bodyguard_1.getReadableFields(new request.payloadType(), request.user, 'obj');
                    selectKeys = [];
                    if ('select' in request.query) {
                        for (_i = 0, _a = request.query.select; _i < _a.length; _i++) {
                            key = _a[_i];
                            key = "obj." + key;
                            selectKeys.push(key);
                        }
                        readableFields = selectKeys;
                    }
                    // Extract Join join query keys
                    if ('join' in request.query) {
                        request.query.join.forEach(function (key) {
                            if (!request.joinMembers.includes(key)) {
                                request.joinMembers.push(key);
                            }
                        });
                    }
                    groupByKeys_2 = [];
                    if ('groupBy' in request.query) {
                        request.query.groupBy.forEach(function (key) {
                            groupByKeys_2.push(key);
                        });
                        // Add 'id' to array if not already
                        if (readableFields.includes('obj.id') &&
                            !('id' in request.query.groupBy)) {
                            groupByKeys_2.push('id');
                        }
                    }
                    orderByKeys = [];
                    orderByOrders = [];
                    if ('orderBy' in request.query) {
                        for (key in request.query.orderBy) {
                            orderByKeys.push(key);
                            orderByOrders.push(request.query.orderBy[key] === 'DESC' ? 'DESC' : 'ASC');
                        }
                    }
                    _b = utils_1.createSearchQuery(request.payloadType, request.query), queryString = _b.queryString, queryParams = _b.queryParams;
                    // Join bodyguard keys, unless this is the User
                    if (request.payloadType !== request.userType) {
                        bodyguardKeys = bodyguard_1.getBodyguardKeys(new request.payloadType());
                        bodyguardKeys.forEach(function (key) {
                            if (!request.joinMembers.includes(key)) {
                                request.joinMembers.push(key);
                            }
                        });
                        // Append to where clause
                        // TODO: [Issue #146] The following code creates a bug, where if a user is authenticated
                        // 	and not admin, they will be unable to view the resource, including AnyoneCanRead()
                        // 	keys.
                        // 	Although the initial purpose for the exact code is scarcely documented, it is believed
                        // 	to be used to prevent the database from pulling enourmous payloads that will be filtered
                        // 	extensively (to dramatically reduce runtime of the guards and filters).
                        /*
                        if (
                            bodyguardKeys &&
                            request.user &&
                            request.user.role !== UserRole.Admin
                        ) {
                            if (queryString.length) {
                                queryString += ' AND ';
                            }
            
                            queryString += '(';
                            bodyguardKeys.forEach(key => {
                                queryString += `obj.${key}=:bodyGuard${key} OR `;
            
                                queryParams['bodyGuard' + key] = request.user.id;
                            });
            
                            queryString = queryString.replace(/ OR +$/, '');
                            queryString += `)`;
                        }
                        */
                    }
                    return [4 /*yield*/, request.repository
                            .createQueryBuilder('obj')
                            .select(readableFields)];
                case 2:
                    selection = _f.sent();
                    _c = 0, _d = request.joinMembers;
                    _f.label = 3;
                case 3:
                    if (!(_c < _d.length)) return [3 /*break*/, 6];
                    table = _d[_c];
                    return [4 /*yield*/, selection.leftJoinAndSelect("obj." + table, table)];
                case 4:
                    selection = _f.sent();
                    _f.label = 5;
                case 5:
                    _c++;
                    return [3 /*break*/, 3];
                case 6:
                    query = selection.where(queryString).setParameters(queryParams);
                    if (!shouldCount) {
                        // Add group by keys
                        for (_e = 0, groupByKeys_1 = groupByKeys_2; _e < groupByKeys_1.length; _e++) {
                            key = groupByKeys_1[_e];
                            query.addGroupBy(key);
                        }
                        // Add order by keys
                        for (i = 0; i < orderByKeys.length; i++) {
                            key = orderByKeys[i];
                            // Object alias must be prepended if join tables exist,
                            // but this field isn't from a join
                            if (!key.includes('.')) {
                                key = 'obj.' + key;
                            }
                            query.addOrderBy(key, orderByOrders[i]);
                        }
                        // Add limit
                        if ('limit' in request.query && request.query.limit) {
                            query.take(request.query.limit);
                        }
                        // Add offset
                        if ('offset' in request.query && request.query.offset) {
                            query.skip(request.query.offset);
                        }
                    }
                    if ('raw' in request.query && request.query.raw) {
                        return [2 /*return*/, query.getRawMany()];
                    }
                    else if (groupByKeys_2.length) {
                        prestring_1 = "obj_";
                        return [2 /*return*/, query.getRawMany().then(function (result) {
                                if (result instanceof Array && result.length) {
                                    result = result.map(function (resource) {
                                        var obj = new request.payloadType();
                                        for (var key in resource) {
                                            obj[key.replace(prestring_1, '')] = resource[key];
                                        }
                                        return obj;
                                    });
                                }
                                return result;
                            })];
                    }
                    else {
                        return [2 /*return*/, query.getMany()];
                    }
                    return [3 /*break*/, 8];
                case 7: 
                // Read all
                return [2 /*return*/, request.repository.find()];
                case 8: return [2 /*return*/];
            }
        });
    });
}
exports.getQuery = getQuery;
//# sourceMappingURL=get-query.js.map