"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Specify allowed query-types and allowed values
 */
exports.queryTypes = {
    select: ['array'],
    where: ['object'],
    whereAnyOf: ['object'],
    search: ['string', 'object'],
    not: ['object'],
    raw: ['boolean', 'string'],
    join: ['array'],
    between: ['object'],
    lessThan: ['object'],
    lessThanOrEqual: ['object'],
    greaterThan: ['object'],
    greaterThanOrEqual: ['object'],
    groupBy: ['array'],
    orderBy: ['object'],
    limit: ['number', 'string'],
    offset: ['number', 'string'],
    count: ['boolean', 'string'],
    additionalParameters: ['object'],
    id: ['number', 'string']
};
/**
 * Specify allowed query-type keys
 */
exports.queryTypeKeys = Object.keys(exports.queryTypes);
//# sourceMappingURL=query-types.js.map