"use strict";
/**
 * # Test Probes
 *
 * Test probes are middleware functions to help debug routes.
 *
 * ## Core Test Probe
 *
 * The core test probe logs information about the current environent
 * (node version, pointyapi version, etc)
 *
 * ## Request Test Probe
 *
 * Troubleshoot incoming requests with the request test probe. This
 * logs information about the current request & body
 *
 * ## User Test Probe
 *
 * Troubleshoot incoming requests by user with the user test probe. This
 * logs information about the auth token & authorized user
 */
Object.defineProperty(exports, "__esModule", { value: true });
var core_test_probe_1 = require("./test-probe/core-test-probe");
exports.coreTestProbe = core_test_probe_1.coreTestProbe;
var request_test_probe_1 = require("./test-probe/request-test-probe");
exports.requestTestProbe = request_test_probe_1.requestTestProbe;
var user_test_probe_1 = require("./test-probe/user-test-probe");
exports.userTestProbe = user_test_probe_1.userTestProbe;
var create_mock_request_1 = require("./test-probe/create-mock-request");
exports.createMockRequest = create_mock_request_1.createMockRequest;
//# sourceMappingURL=test-probe.js.map