"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ROOT_PATH = require('app-root-path').toString();
// Package.json interface
var pkg = {
    version: '',
    dependencies: {
        typescript: '',
        express: '',
        typeorm: ''
    }
};
// Try to load package.json
try {
    pkg = require(ROOT_PATH + '/node_modules/pointyapi/package.json');
}
catch (ex) {
    pkg = require(ROOT_PATH + '/package.json');
}
/**
 * Core Test Probe: Log results about the Node & PointyAPI Environment
 */
function coreTestProbe(request, response, next) {
    console.log('\n[DEBUG] [Core Test Probe]\n');
    console.log('PointyAPI v', pkg.version);
    console.log('TypeScript v', pkg.dependencies.typescript);
    console.log('Express v', pkg.dependencies.express);
    console.log('TypeORM v', pkg.dependencies.typeorm);
    console.log('\n------------------------------------------------------------');
    next();
}
exports.coreTestProbe = coreTestProbe;
//# sourceMappingURL=core-test-probe.js.map