"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var typeorm_1 = require("typeorm");
/**
 * Add a resource to the database. This is useful for filling out database with
 * 	admin/developer resources
 * @param type Model type the resource should belong to
 * @param resource Parameters to create the resource by
 * @return Returns a Promise
 */
function addResource(type, resource) {
    return typeorm_1.getRepository(type).save(resource).catch(function (error) {
        console.warn('[addResource] ', error.message);
    });
}
exports.addResource = addResource;
//# sourceMappingURL=add-resource.js.map