import { BaseModel, BaseUser } from '../models';
/**
 * Check if the user matches a BodyguardKey for the object
 * @param obj Object to check
 * @param user User to check for matching BodyguardKey
 * @param objType Type of object
 * @param userType Type of user
 * @param objBodyguardKeys Bodyguard keys which belong to the object
 * @param userBodyguardKeys Bodyguard keys which belong to the user
 * @return Returns if the user owns this object
 */
export declare function isSelf(obj: BaseModel | BaseModel[], user: BaseUser, objType: any, userType: any, objBodyguardKeys?: string[], userBodyguardKeys?: string[]): boolean;
