import { Request, Response } from 'express';
import { BaseModel } from '../models';
/**
 * Run specified hook in the model
 * @param name Name of hook to run
 * @param obj Object to run hook on
 * @param request Request object to pass to hook
 * @param response Response object to pass to hook
 * @return Returns of a Promise of boolean
 */
export declare function runHook(name: string, obj: BaseModel | BaseModel[], request: Request, response: Response): Promise<boolean>;
